/**
 * Copyright (C) 2010-2011 J.W.Marsden
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/
package jsonij.json;

import java.io.Serializable;

public class NumericImp extends Value implements Serializable {

    /**
     * Container for the String.
     */
    protected Number number;

    public NumericImp(Number numberValue) {
        number = numberValue;
    }

    /* (non-Javadoc)
     * @see com.realitypipe.json.Value#type()
     */
    @Override
    protected TYPE type() {
        return TYPE.NUMERIC;
    }

    public byte byteValue() {
        return number.byteValue();
    }

    public double doubleValue() {
        return number.doubleValue();
    }

    public float floatValue() {
        return number.floatValue();
    }

    public int intValue() {
        return number.intValue();
    }

    public long longValue() {
        return number.longValue();
    }

    public short shortValue() {
        return number.shortValue();
    }

    @Override
    public Number getNumber() {
        return number;
    }

    @Override
    public int nestedSize() {
        return 0;
    }

    /* (non-Javadoc)
     * @see com.realitypipe.json.Value#toJSON()
     */
    @Override
    public String toJSON() {
        return number.toString();
    }
}
